@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory


@if (DataLoading)
{
    <h4>@loading_message</h4>
}


<div class="form-group">
        <h5>
            <b>Bodegas:</b>
        </h5>
    <select name="bodegas" class="form-control" @onchange="OnChangedWarehouse">
        <label for="">Bodegas:</label>
        @foreach (var warehouse in warehouses)
        {
            <option value="none" selected disabled hidden>Elige una Bodega ..</option>
            <option value="@warehouse.WarehouseId">@warehouse.WarehouseName</option>
        }
    </select>
</div>
<br>
<br>

<div>
    <EditForm Model="oSTransaction">
        <h5>
            <b>Productos:</b>
        </h5>
        <div class="form-group">
            <InputSelect class="form-control" @bind-Value="oSTransaction.StorageId">
                <option value="none" selected disabled hidden>Elige un Producto ..</option>
                @foreach (var storage in storages)
                {
                    @if (storage is not null)
                    {
                        <option value="@storage.StorageId">@storage.Product?.ProdName</option>
                    }
                }

            </InputSelect>
            <br>
            <br>

            <h5>
                <b>Product Quantity:</b>
            </h5>
            <div class="form-group">
                <InputNumber type="number" class="form-control" 
                        @bind-Value="oSTransaction.ProductQuantity" ParsingErrorMessage="Must be an integer value"  />
            </div>
            <br>
            <br>

            <h5>
                <b>Tipo de Transaccion :</b>
            </h5>
            <div>
                <InputCheckbox type="checkbox" class="form-check-input" 
                    @bind-Value="oSTransaction.IsProductIn" id="flexCheckChecked" />    
                <label class="form-check-label" for="flexCheckDefault">
                    Ingresar Producto a Bodega
                </label>
            </div>
        </div>
    </EditForm>
</div>
<br>

<input type="button" value="Agregar Transacccion" @onclick="SaveTransaction">

<br>
<br>
<br>

<h5>@transactions_message</h5>


@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching Storages from DB ...";
    private string transactions_message = string.Empty;

    B_STransactions bSTransaction = null!;
    Storage_Transaction oSTransaction = new();

    B_Storage bStorage = null!;
    List<Storage> storages = new();
    Storage oStorage = new();

    B_Warehouse bWarehouse = null!;
    List<Warehouse> warehouses = new();
    Warehouse oWarehouse = new();

    B_Product bProduct = null!;
    List<Product> products = new();
    Product oProduct = new();


    protected override async Task OnInitializedAsync()
    {
        if (DataLoading)
        {
            return;
        }

        try
        {
            DataLoading = true;

            bSTransaction = new (ContextFactory);
            bStorage = new (ContextFactory);
            bWarehouse = new (ContextFactory);
            bProduct = new (ContextFactory);

            warehouses = await bWarehouse.GetWarehouses();

            
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
        
        await base.OnInitializedAsync();
    }

    private async Task OnChangedWarehouse(ChangeEventArgs e)
    {
        if (e.Value is not null && bStorage is not null)
        {
            var wid = int.Parse(e.Value?.ToString()); // wid = Warehouse Id
            storages = await bStorage.GetProductsByWarehouse(wid);
        }
    }

    private async Task SaveTransaction()
    {
        transactions_message = string.Empty;
        oStorage = storages.LastOrDefault(s => s.StorageId == oSTransaction.StorageId);

        oProduct = oStorage.Product;
        oWarehouse = oStorage.Warehouse;

        if (bStorage is not null && oSTransaction is not null && (oSTransaction.ProductQuantity > 0))
        {
            if (oSTransaction.IsProductIn)
            {
                oStorage.PartialQuantity += oSTransaction.ProductQuantity;
                await bStorage.UpdateStorage(oStorage);

                oProduct.TotalQuantity += oSTransaction.ProductQuantity;
                await bProduct.UpdateProduct(oProduct);

                transactions_message = $"Se han agregado {oSTransaction.ProductQuantity} unidad(es) de {oProduct.ProdName} a {oWarehouse?.WarehouseName}. Ahora tienes {oStorage.PartialQuantity} unidad(es) disponibles en Bodega";

                warehouses = await bWarehouse.GetWarehouses(); // Reset list of Warehouses              
            }
            else 
            {
                transactions_message = string.Empty;

                if ((oStorage is not null) && (oProduct is not null) 
                    && (oStorage.PartialQuantity >= 0) | (oProduct?.TotalQuantity >= 0)
                    && (oStorage.PartialQuantity  >= oSTransaction.ProductQuantity )     
                )
                {
                    oStorage.PartialQuantity -= oSTransaction.ProductQuantity;
                    oProduct.TotalQuantity -= oSTransaction.ProductQuantity;
                    
                    await bStorage.UpdateStorage(oStorage);
                    await bProduct.UpdateProduct(oProduct);

                    transactions_message = $"Se han retirado {oSTransaction?.ProductQuantity} unidad(es) de {oProduct?.ProdName} de {oWarehouse?.WarehouseName}. Ahora tienes {oStorage?.PartialQuantity} unidad(es) disponibles en esta Bodega";

                    warehouses = await bWarehouse.GetWarehouses(); // Reset list of Warehouses              
                }
                else
                {
                    warehouses = await bWarehouse.GetWarehouses(); // Reset list of Warehouses              
                    transactions_message = $"La cantidad de unidad(es) solicitada del producto {oProduct?.ProdName} es superior a las {oStorage?.PartialQuantity} unidad(es) disponibles en {oWarehouse?.WarehouseName}";
                }
            }


            await bSTransaction.CreateTransaction(oSTransaction);
            oSTransaction = new (); // Reset Transactions form field
        }
    }
}